using System;
using System.Collections.Generic;
using System.Text;

namespace TheaterTek
{
    static class TheaterTekMessages
    {
        // The following two variables keep track of the last command that was sent.  This is needed
        // because we need to wait for a success from one command before we can send another one.

        //Global LastCommand As String
        //Global CommandSuccess As Boolean

        //IP COMMANDS
        //-----------

        //TT->AP		Sent from TT to client application
        //AP->TT		Sent from client application to TT
        //TT<-->AP	Sent from TT and can be polled by client.

        //Commands are sent ASCII in the form:
        //4 byte command, space, {parameter} CRLF

        //A successful command returns:
        //Command, space, 0
        //OR
        //Command, space, response

        //An unsuccessful command returns:
        //Command, space, -1

        //Example:
        //0000			// Client app
        //0000 TheaterTek DVD	// Returned value


        //Enum values
        //-----------
        //IP_MEDIASTATE 0 = Stopped / NoMedia, 1 = Playing, 2 = paused, 3 = FF, 4 = RW
        //IP_FULLSCREEN 0 = Minimized, 1 = Windowed, 2 = Fullscreen
        //IP_GETPRIVATE   Allows client to set/get a private string up to 1024 bytes on TT. This data persists as long as TT is running.


        public const string MYCONST = "ddd";
        public const string IP_APPLICATION = "0000";      // TT<-->AP  Application name
        public const string IP_VERSION = "0001";          // TT<-->AP  Application version
        public const string IP_FLASH = "0500";            // TT<-->AP  OSD Flash message
        public const string IP_FULLSCREEN = "0510";       // TT<-->AP  Fullscreen/windowed status

        public const string IP_MEDIASTATE = "1000";      // TT<-->AP  State enum
        public const string IP_MEDIATIME = "1010";       // TT<-->AP  Media time (hh:mm:ss / hh:mm:ss)
        public const string IP_MEDIAPOS = "1020";        // AP->TT    Set media time (hh:mm:ss)
        public const string IP_ENDOFMEDIA = "1030";      // TT->AP    Signals end of media
        public const string IP_FORMAT = "1040";          // TT->AP    (0=NTSC, 1=PAL)

        public const string IP_GETAR = "1300";           // TT<-->AP  Return Current AR (name)
        public const string IP_ARCOUNT = "1310";         // AP->TT    AR Count
        public const string IP_ARNAMES = "1320";         // AP->TT    AR Names (name|name)
        public const string IP_SETAR = "1330";           // AP->TT    Set Current AR (number)

        public const string IP_CURFILE = "1400";         // TT<-->AP  Current file
        public const string IP_DISKINSERTION = "1410";   // TT->AP    Disk inserted
        public const string IP_DISKEJECTION = "1420";    // TT->AP    Disk ejected

        public const string IP_DVDUNIQUEID = "1500";     // AP->TT    DVD unique ID
        public const string IP_DVDTITLE = "1510";        // TT<-->AP  Current Title
        public const string IP_DVDTITLECOUNT = "1520";   // AP->TT    Title count
        public const string IP_DVDPLAYTITLE = "1530";        // AP->TT    Play Title

        public const string IP_DVDCHAPTER = "1600";      // TT<-->AP  Current Chapter
        public const string IP_DVDCHAPTERCOUNT = "1610"; // AP->TT    Chapter count
        public const string IP_DVDPLAYCHAPTER = "1620";  // AP->TT    Play chapter
        public const string IP_DVDPLAYTITCHAP = "1630";  // AP->TT    Play Chapter in Title (Chapter Title)

        public const string IP_DVDAUDIO = "1700";        // TT<-->AP  Current audio stream
        public const string IP_DVDSETAUDIO = "1710";         // AP->TT    Set audio stream
        public const string IP_DVDAUDIOCOUNT = "1720";   // AP->TT    Audio stream count
        public const string IP_DVDAUDIONAMES = "1730";   // AP->TT    Audio stream names (name|name)

        public const string IP_DVDSUBTITLE = "1800";         // TT<-->AP  Current subtitle stream
        public const string IP_DVDSETSUBTITLE = "1810";  //   AP->TT  Set subtitle stream, -1 to disable
        public const string IP_DVDSUBTITLECOUNT = "1820";    // AP->TT    Subtitle stream count
        public const string IP_DVDSUBTITLENAMES = "1830";    // AP->TT    Subtitle names (name|name)

        public const string IP_DVDANGLE = "1900";        // TT<-->AP  Current angle
        public const string IP_DVDSETANGLE = "1910";         // AP->TT    Set angle
        public const string IP_DVDANGLECOUNT = "1920";   // AP->TT    Angle count

        public const string IP_DVDMENUMODE = "2000";         // TT<-->AP  Menu mode
        public const string IP_DOMAIN = "2010";      // TT->AP    DVD Domain

        public const string IP_GETVOLUME = "2100";       // TT<-->AP  Get Current volume
        public const string IP_SETVOLUME = "2110";       // AP->TT    Set Current volume
        public const string IP_GETAUDIOOUTPUT = "2120";  // AP->TT    Get Current audio output
        public const string IP_SETAUDIOOUTPUT = "2130";  // AP->TT    Set audio output

        public const string IP_ADDBOOKMARK = "2200";         // AP->TT    Add a bookmark
        public const string IP_NEXTBOOKMARK = "2210";        // AP->TT    Next bookmark
        public const string IP_PREVBOOKMARK = "2220";        // AP->TT    Previous bookmark

        public const string IP_PLAYFILE = "3000";        // AP->TT    Play file
        public const string IP_ADDFILE = "3010";         // AP->TT    Add file to playlist
        public const string IP_CLEARLIST = "3020";       // AP->TT    Clear playlist
        public const string IP_GETINDEX = "3030";        // AP->TT    Current item index
        public const string IP_PLAYATINDEX = "3040";         // AP->TT    Play item at index
        public const string IP_GETLISTCOUNT = "3050";        // AP->TT    Current list count
        public const string IP_GETLIST = "3060";         // AP->TT    Get playlist (name|name)
        public const string IP_DELATINDEX = "3070";      // AP->TT    Delete file at index

        public const string IP_SETPRIVATE = "4000";      // AP->TT    Private app string
        public const string IP_GETPRIVATE = "4010";      // AP->TT    Private app string

        public const string IP_WM_COMMAND = "5000";      // AP->TT    Internal command
        public const string IP_KEYPRESS = "5010";        // AP->TT    Key code
        public const string IP_SENDMSG = "5020";         // AP->TT    Send message
        public const string IP_POSTMSG = "5030";         // AP->TT    Post message


        // Auto Killer Commands
        // --------------------
        public const string IP_LAUNCH = "8000";      // AP->AK
        public const string IP_QUIT = "8010";            // AP->AK
        public const string IP_MOUNTDISK = "8020";       // AP->AK    Changer#, Slot#
        public const string IP_UNMOUNTDISK = "8030";         // AP->AK    Changer#  ->Slot#
        public const string IP_EJECTDISK = "8040";       // AP->AK    Changer#, Slot#
        public const string IP_GETSLOTDATA = "8050";         // AP->AK    Changer#, Slot#
        public const string IP_GETDRIVEDATA = "8060";        // AP->AK    Changer#  ->DriveData
        public const string IP_CHECKCHANGED = "8070";        // AP->AK
        public const string IP_REBUILDDATA = "8080";         // AP->AK
        public const string IP_DATACHANGED = "8100";         // AK->AP    Notification of data change
        public const string IP_COUNTCHANGERS = "8110";   // AP->AK


        // WM_COMMANDS
        // -----------
        public const string ID_PLAY = "32771";
        public const string ID_STOP = "32772";
        public const string ID_PAUSE = "32773";
        public const string ID_NEXT = "32774";
        public const string ID_PREVIOUS = "32775";
        public const string ID_EXIT = "32776";
        public const string ID_FF = "32777";
        public const string ID_RW = "32778";
        public const string ID_MENU_LIST = "32779";
        public const string ID_TITLE_MENU = "32780";
        public const string ID_FF_1X = "32782";
        public const string ID_FF_2X = "32784";
        public const string ID_FF_5X = "32785";
        public const string ID_FF_10X = "32786";
        public const string ID_FF_20X = "32787";
        public const string ID_FF_SLOW = "32788";
        public const string ID_RW_1X = "32790";
        public const string ID_RW_2X = "32791";
        public const string ID_RW_5X = "32792";
        public const string ID_RW_10X = "32793";
        public const string ID_RW_20X = "32794";
        public const string ID_ROOT_MENU = "32796";
        public const string ID_AUDIO_MENU = "32797";
        public const string ID_SUBTITLE_MENU = "32798";
        public const string ID_CHAPTER_MENU = "32799";
        public const string ID_CC_ON = "32804";
        public const string ID_CC_OFF = "32805";
        public const string ID_ABOUT = "32807";
        public const string ID_SUB_OFF = "32808";
        public const string ID_ASPECT_DEFINE = "32810";
        public const string ID_ASPECT_ANAM = "32811";
        public const string ID_ASPECT_NONANAM = "32812";
        public const string ID_ASPECT_LETTERBOX = "32813";
        public const string ID_BOOK_ADD = "32814";
        public const string ID_BUTTON32819 = "32819";
        public const string ID_BUTTON32820 = "32820";
        public const string ID_ONSCREEN = "32821";
        public const string ID_VID_BRIGHTNESS = "32824";
        public const string ID_VID_CONTRAST = "32825";
        public const string ID_VID_HUE = "32826";
        public const string ID_VID_SATURATION = "32827";
        public const string ID_OVERSCAN = "32828";
        public const string ID_VID_GAMMA = "32829";
        public const string ID_MENU_CHAPTER = "32830";
        public const string ID_MENU_AUDIO = "32831";
        public const string ID_MENU_ANGLE = "32832";
        public const string ID_MENU_FF = "32833";
        public const string ID_MENU_SUBTITLES = "32834";
        public const string ID_CLOSED_CAPTIONS = "32835";
        public const string ID_BOOK_DELETE = "32836";
        public const string ID_ANGLE_MENU = "32837";
        public const string ID_RESUME = "32838";
        public const string ID_MENU_TITLE = "32839";
        public const string ID_SETUP = "32841";
        public const string ID_ADJUSTVIDEO = "32842";
        public const string ID_ASPECT_LOCK = "32843";
        public const string ID_SETSTARTPOINT = "32846";
        public const string ID_K_RETURN = "32849";
        public const string ID_K_UP = "32850";
        public const string ID_K_DOWN = "32851";
        public const string ID_K_LEFT = "32852";
        public const string ID_K_RIGHT = "32853";
        public const string ID_K_FF = "32854";
        public const string ID_K_RW = "32855";
        public const string ID_K_ESCAPE = "32856";
        public const string ID_NEXTAR = "32857";
        public const string ID_INFO = "32858";
        public const string ID_ARFIRST = "32859";
        public const string ID_AR2 = "32860";
        public const string ID_AR3 = "32861";
        public const string ID_AR4 = "32862";
        public const string ID_AR5 = "32863";
        public const string ID_AR6 = "32864";
        public const string ID_AR7 = "32865";
        public const string ID_AR8 = "32866";
        public const string ID_AR9 = "32867";
        public const string ID_ARLAST = "32868";
        public const string ID_EJECT = "32870";
        public const string ID_CONTEXT = "32872";
        public const string ID_ALTEXIT = "32873";
        public const string ID_MINIMIZE = "32874";
        public const string ID_NEXTSUB = "32875";
        public const string ID_NEXTAUDIO = "32876";
        public const string ID_REPLAY = "32877";
        public const string ID_JUMP = "32878";
        public const string ID_FRAMESTEP = "32879";
        public const string ID_ABREPEAT = "32880";
        public const string ID_CHAPTITREP = "32881";
        public const string ID_NEXT_ANGLE = "32883";
        public const string ID_OPEN = "32884";
        public const string ID_NEXT_TIT = "32885";
        public const string ID_STATS = "32886";
        public const string ID_CAPTURE = "32887";
        public const string ID_BK_RESUME = "32888";
        public const string ID_DEINTERLACE = "32889";
        public const string ID_VOLUP = "32891";
        public const string ID_VOLDOWN = "32892";
        public const string ID_NEXTDISK = "32893";
        public const string ID_SHOWTIME = "32894";
        public const string ID_CC_NUDGE_UP = "32895";
        public const string ID_CC_NUDGE_DOWN = "32896";
        public const string ID_UPGRADE = "32897";
        public const string ID_NEXT_FILE = "32898";
        public const string ID_PREVIOUS_FILE = "32899";
        public const string ID_TSPROG = "32901";
        public const string ID_PREV_TIT = "32902";
        public const string ID_SLOW = "32904";
        public const string ID_CCTOGGLE = "32905";
        public const string ID_AR11 = "32906";
        public const string ID_AR12 = "32907";
        public const string ID_AR13 = "32908";
        public const string ID_AR14 = "32909";
        public const string ID_AR15 = "32910";
        public const string ID_AR16 = "32911";
        public const string ID_AR17 = "32912";
        public const string ID_AR18 = "32913";
        public const string ID_AR19 = "32914";
        public const string ID_AR20 = "32915";
        public const string ID_VMRSTATS = "32916";
        public const string ID_LIPDOWN = "32917";
        public const string ID_LIPUP = "32918";
        public const string ID_MUTE = "32919";
        public const string ID_BLANKING = "32920";
        public const string ID_TOGGLE = "32922";
        public const string ID_MOVELEFT = "32924";
        public const string ID_MOVERIGHT = "32925";
        public const string ID_MOVEUP = "32926";
        public const string ID_MOVEDOWN = "32927";
        public const string ID_H_EXPAND = "32928";
        public const string ID_H_CONTRACT = "32929";
        public const string ID_V_EXPAND = "32930";
        public const string ID_V_CONTRACT = "32931";
        public const string ID_ZOOM_IN = "32932";
        public const string ID_ZOOM_OUT = "32933";
        public const string ID_BL_LEFT = "32934";
        public const string ID_BL_RIGHT = "32935";
        public const string ID_BT_UP = "32936";
        public const string ID_BT_DOWN = "32937";
        public const string ID_BR_LEFT = "32938";
        public const string ID_BR_RIGHT = "32939";
        public const string ID_BB_UP = "32940";
        public const string ID_BB_DOWN = "32941";
        public const string ID_STREAM = "32943";
    }
}
